<?php
include("./CommandAPI.php");

$Msg=substr($INFO['MSG'], strlen("~umode"));
$Msg=trim($Msg);

$To=$_Bot->getDest($INFO['DEST'], $_User->getNick());

if (!strstr($Msg, ' ')){
	Wise_Msg($To, "You must specify mode(s) and a nick name");
	Wise_Msg($To, "umode <mode(s)> <nick>");
	exit;
}

$Modes=substr($Msg, 0, strpos($Msg, ' '));
$Nick=substr($Msg, strpos($Msg, ' '));

$Modes=addslashes(trim($Modes));
$Nick=addslashes(trim($Nick));

if ($Modes{0}=='-'){
	$Type='remove';
	$Modes=substr($Modes, 1);
}
else if ($Modes{0}=='+'){
	$Type='add';
	$Modes=substr($Modes, 1);
}
else {
	$Type='add';
}

if (!preg_match('/^[A-Za-z0-9_,-]+$/', $Modes)){
	Wise_Msg($To, 'Invalid mode string');
	exit;
}

$Modes=explode(',',$Modes);
while (in_array('R',$Modes)){
	unset($Modes[array_search('R',$Modes)]);
}

$res=db_query("SELECT Modes FROM users WHERE Nick='{$Nick}'");
if (!$res || db_num_rows($res)==0){
	//May just not be added yet, so will will try adding them by making a new user
	new User($Nick);
	$res=db_query("SELECT Modes FROM users WHERE Nick='{$Nick}'");
	if (!$res || db_num_rows($res)==0){
		//Nope, can't get data.
		Wise_Msg($To, "Couldn't get info about their current modes.  None added");
		exit;
	}
}

$CurModes=db_get_row($res);
$CurModes=toArray($CurModes->Modes);
$remove=false;
if ($Type=='remove'){
	foreach ($Modes as $Mode){
		while (in_array($Mode, $CurModes)){
			unset($CurModes[array_search($Mode, $CurModes)]);
		}
	}
}
else {
	foreach ($Modes as $Mode){
		if (!in_array($Mode, $CurModes)){
			$CurModes[]=$Mode;
		}
	}
}

if ($Modes=='' && $remove==false){
	Wise_Msg($To, "Modes already exist");
	exit;
}

$CurModes=addslashes(toArrayString($CurModes));
$res=db_query("UPDATE users SET Modes='{$CurModes}' WHERE Nick='{$Nick}'");
if (!$res){
	Wise_Msg($To, "Unable to change modes");
}
else {
	$b=$_Bot->getInfo('bold');
	if ($remove==false){
		Wise_Msg($To, "Added modes {$b}".implode(',',$Modes)."{$b} to {$b}{$Nick}{$b}");
	}
	else {
		Wise_Msg($To, "Removed modes {$b}".implode(',',$Modes)."{$b} from {$b}{$Nick}{$b}");
		if (count(toArray($CurModes))==0){
			Wise_Msg($To, "Modes are now empty");
		}
	}
}
?>
