<?php
session_start();
include("./common.php");
set_time_limit(120);
$Admin=null;
function login($msg){
	if ($_GET['action']=='login'){
		$_GET['action']=='main';
	}
	header_html("Administration - Login");
	echo "<P>{$msg}</P>
			<FORM ACTION=\"admin.php?action=login\" METHOD=\"post\">
			<INPUT TYPE=\"hidden\" VALUE=\"{$_GET['action']}\" NAME=\"oldAction\">
			<INPUT TYPE=\"text\" VALUE=\"\" NAME=\"nick\"> Nick<BR>
			<INPUT TYPE=\"password\" VALUE=\"\" NAME=\"pass\"> Pass<BR>
			<INPUT TYPE=\"submit\" VALUE=\"Login\">
			</FORM>";
	footer();
}


if (!isset($_GET['action'])){
	$_GET['action']='main';
}

//Security check first
if (!isset($_SESSION['pass']) && $_GET['action'] != 'login'){
	login("Please login before you make any changes to the bot.  Enter your nick and password 
			below.  Your password will be the same as for IRC.");
	exit;
}
else if ($_GET['action']=='login'){
	if (isset($_POST['nick']) && User::exists($_POST['nick'])){
		$Admin=new User($_POST['nick']);
		if ($Admin->hasMode('MASTER')){
			if (md5($_POST['pass'])==$Admin->getProperty('Pass')){
				$_SESSION['pass']=md5($_POST['pass']);
				$_SESSION['nick']=$_POST['nick'];
				$_GET['action']=$_POST['oldAction'];
			}
			else {
				login("You entered in the wrong password for that nick name.  Please double check 
						your spelling and try again.");
				exit;
			}
		}
		else {
			login("That nickname does not have access to this area of the bot.  Please make sure 
					you entered the right nick and have permission for this.");
			exit;
		}
	}
	else if (isset($_POST['nick'])) {
		login("I know no such nick name.  Please try again.");
		exit;
	}
	else {
		login("Please login before you make any changes to the bot.  Enter your nick and password 
				below.  Your password will be the same as for IRC.");
		exit;
	}
}
else if (isset($_SESSION['pass'])){
	if (!isset($_SESSION['nick'])){
		login("Please login before you make any changes to the bot.  Enter your nick and password 
				below.  Your password will be the same as for IRC.");
		exit;
	}
	else {
		if (User::exists($_SESSION['nick'])){
			$Admin=new User($_SESSION['nick']);
			if ($Admin->hasMode('MASTER')){
				if ($_SESSION['pass']!=$Admin->getProperty('Pass')){
					login("You entered in the wrong password for that nick name.  Please double check 
							your spelling and try again.");
					exit;
				}
			}
			else {
				login("That nickname does not have access to this area of the bot.  Please make sure 
						you entered the right nick and have permission for this.");
				exit;
			}
		}
		else {
			login("I know no such nick name.  Please try again.");
			exit;
		}
	}
}


if (empty($_GET['action'])){
	$_GET['action']='main';
}


if ($_GET['action']=='saved'){
	header_html('Administration - Information Saved');
}
else if ($_GET['action']=='config'){
	header_html('Administration - Configure');
}
else if ($_GET['action']=='review'){
	if (isset($_GET['file'])){
		header_html('Administration - Review log files - '.$_GET['file']);
	}
	else {
		header_html('Administration - Review log files');
	}
}
else if ($_GET['action']=='run'){
	header_html('Administration - Run IRC Commands');
}
else if ($_GET['action']=='modules'){
	header_html('Administration - Edit modules');
}
else if ($_GET['action']=='modules_delete'){
	if (isset($_GET['module_name'])){
		header_html('Delete module '.$_GET['module_name'].'?');
	}
	else {
		header_html('Delete module - Select');
	}
}
else if ($_GET['action']=='modules_install'){
	//Will output the header information when this option is selected
	if (!isset($_FILES['installsql']) || strtolower($_FILES['installsql']['name']) != 'install.sql'){
		header_html("Module installation - Select file");
	}
}
else {
	header_html('Administration');
}

switch ($_GET['action']){
	case 'main':{
		echo "<P>Welcome to the admin section for <I><B>".$Bot->getNick()."</B></I>.  Here you can set various config 
				options and edit users accounts.  You can also tell the bot to do things on IRC if you just need a quick 
				command run and you can also view the log files for the bot!  All this adds up to be one heck of a control 
				center eh?</P>

				<P>What would you like to do with the bot today?</P>
				
				<TABLE BORDER=\"0\" CELLPADDING=\"6\" CELLSPACING=\"15\">
					<TR>
						<TD CLASS=\"AdminCmd\"><A HREF=\"admin.php?action=config\">Change configuration</A></TD>
						<TD CLASS=\"AdminCmd\"><A HREF=\"admin.php?action=review\">Review log files</A></TD>
					</TR>
					<TR>
						<TD CLASS=\"AdminCmd\"><A HREF=\"admin.php?action=run\">Run some IRC commands</A></TD>
						<TD CLASS=\"AdminCmd\"><A HREF=\"admin.php?action=modules\">View/Edit modules</A></TD>
					</TR>
					<TR>
						<TD CLASS=\"AdminCmd\">&nbsp;</TD>
						<TD CLASS=\"AdminCmd\">&nbsp;</TD>
					</TR>
				</TABLE>
				";
		break;
	}
	case 'save':{
		foreach($_POST as $key=>$val){
			if (substr($key, 0, 4)=='cfg_'){
				$key=substr($key, 4);
				$key=stripslashes($key);
				$val=stripslashes($val);

				if ($key=='cmd_host'){
					if (substr($val, 0, 7)=='http://'){
						$val=substr($val, 7);
					}
					if($val{strlen($val)-1}=='/' || $val{strlen($val)-1}=='\\'){
						$val=substr($val, 0, -1);
					}
				}
				$Bot->setCfg($key, $val);
			}
		}
		echo '<P>Your new information has been saved.  You can make more edits if you wish of you can leave and ';
		echo 'check out the changes for yourself.</P>';
	}
	case 'config':{
		echo "<SCRIPT TYPE=\"text/javascript\">
				  <!--
				function addItem(sele){
					var value=prompt('Add what?','');
					var ind=sele.length;
					sele[ind]=new Option(value, value);
					sele.selectedIndex=ind;
				}

				function removeItem(sele){
					//If there isn't one selected, ask for it and get the ID relating to it.
					if (sele.selectedIndex==-1){
						var defVal=(sele.length>0)?sele[0].text:'';
						var value=prompt('Which should I remove?',defVal);
						for (var x=0; x<sele.length; x++){
							if (sele[x].text==value){
								sele.selectedIndex=x;
								break;
							}
						}
					}
					var ind=sele.selectedIndex;
					sele[ind]=null;
					if (ind < sele.length){
						sele.selectedIndex=ind;
					}
				}

				function getValues(frm){
					for (var i=0; i<frm.elements.length; i++){
						if ((frm.elements[i].type.substring(0, 6)=='select') && (frm.elements[i].name.substring(0,4) != 'cfg_')){
							var name=frm.elements[i].name;
							var val=\"['\";
							for (var x=0; x<frm.elements[i].length; x++){
								val+=frm.elements[i].options[x].text.replace(\"'\",\"\\\\'\")+\"','\";
							}
							if (frm.elements[i].length != 0){
								val=val.substring(0, val.length-3);
							}
							frm.elements['cfg_'+name].value=val+\"']\";
						}
					}
				}
				  //-->
					</SCRIPT>\n";
		echo "<P>Here you can set various option about the bot configuration.  If you have questions about a certain 
				configuation option please read the read me for bot or for the module if you downloaded one.  Much can be 
				learned from them.</P>
				<CENTER>
				<FORM ACTION=\"admin.php?action=save\" METHOD=\"post\" OnSubmit=\"getValues(this); return true;\">
				<TABLE BORDER=\"0\" CELLPADDING=\"2\" CELLSPACING=\"1\">\n";

				$res=db_query("SELECT name, val, HelpDesc FROM config ORDER BY name");
				while ($row=db_get_row($res)){
					echo "\t\t\t\t\t<TR><TD CLASS=\"Cfg\">".$row->HelpDesc.":</TD><TD>";
					if (substr($row->val, 0, 2) == '[\''){
						echo "<TABLE BORDER=\"0\" CELLPADDING=\"2\">
									<TR>
										<TD>
											<INPUT TYPE=\"hidden\" VALUE=\"\" NAME=\"cfg_".$row->name."\">
										   <SELECT NAME=\"".$row->name."\" SIZE=\"6\" WIDTH=\"200\" STYLE=\"width:200px;\">";

										$values=toArray($row->val);
										foreach($values as $val){
											echo "\t\t\t\t\t<OPTION VALUE=\"$val\">$val</OPTION>\n";
										}

					echo "				</SELECT>
										</TD>
										<TD>
											<INPUT TYPE=\"button\" VALUE=\"Add\" OnClick=\"addItem(this.form['{$row->name}'])\">
											<BR>
											<INPUT TYPE=\"button\" VALUE=\"Remove\" OnClick=\"removeItem(this.form['{$row->name}'])\">
										</TD>
									</TR>
								</TABLE>";
					}
					else if ($row->val=='true' || $row->val=='false') {
						$TCHK=($row->val=='true')?" CHECKED":"";
						$FCHK=(!$TCHK)?" CHECKED":"";
						echo "<INPUT TYPE=\"radio\" VALUE=\"true\" NAME=\"cfg_".$row->name."\"{$TCHK}>Yes &nbsp; * &nbsp;";
						echo "<INPUT TYPE=\"radio\" VALUE=\"false\" NAME=\"cfg_".$row->name."\"{$FCHK}>No";
					}
					else {
						echo "<INPUT TYPE=\"text\" VALUE=\"".$row->val."\" NAME=\"cfg_".$row->name."\" SIZE=\"40\">";
					}
					echo "</TD></TR>\n";
				}
				echo "</TABLE>
						<INPUT TYPE=\"submit\" VALUE=\"Save\">
						</FORM>
						</CENTER>";
		break;
	}
	case 'review':{
		if (!isset($_GET['file'])){
			$_GET['file']='';
		}
		$_GET['file']=str_replace('../','',$_GET['file']);
		$_GET['file']=str_replace('..\\','',$_GET['file']);

		if (empty($_GET['file']) || !file_exists($_GET['file']) || substr($_GET['file'], -4) != '.log'){
			echo '<P>Please select which log file you want to look at from below.  Please remember that ';
			echo 'when you review a log file, it\'s contents is not updated in the web automatically.  So ';
			echo 'if you view the log file the bot is currently working on, you will need to refresh to see ';
			echo 'the newest content.</P>';
			//Find out if they may have changed directorys for the log files.
			$Path=$Bot->getCfg('output_log_prefix');
			$Path=explode('/',str_replace('\\','/', $Path));
			$Addon='';
			for ($i=0; $i<count($Path)-1; $i++){
				$Addon.=$Path[$i].'/';
			}
			if ($Addon{0}=='.'){
				$Addon='.'.$Addon;
			}
			$d=opendir($Addon);
			while ($file=readdir($d)){
				if (is_file($Addon.$file) && substr($file, -4) == '.log'){
					$Size=filesize($Addon.$file);
					$Time=timeFormat(ceil($Size/1024*.0485));
					$Size=FormatSize($Size);
					echo "<A HREF=\"admin.php?action=review&file=";
					echo urlencode($Addon.$file);
					echo "\">{$Addon}{$file}</A> (Size: {$Size} Process Time: {$Time})<BR>";
				}
			}
			echo "<P>Note that process time is about the time it will take to process this log file ";
			echo "in pretty format with all entryies shown.  This is just an estimated time.  The ";
			echo "actual time may be faster or slower.</P>";
		}
		else {
			if (!isset($_GET['format'])){
				$_GET['format']='pretty';
			}
			if (!isset($_GET['channel'])){
				$_GET['channel']='*';
			}

			echo "<H2>{$_GET['file']}</H2><A NAME='top'></A><P><A HREF=\"#bottom\">Go to end</A> - ";

					$query='action=review&file='.urlencode($_GET['file']).'&channel='.urlencode($_GET['channel']);
					echo '<A HREF="admin.php?'.$query.'&format=raw">Raw format</A> - ';
					echo '<A HREF="admin.php?'.$query.'&format=pretty">Pretty format</A></P>';
					if ($_GET['format']=='pretty'){
						echo "<P><FORM ACTION=\"admin.php\" METHOD=\"get\">
						<INPUT TYPE=\"hidden\" VALUE=\"review\" NAME=\"action\">
						<INPUT TYPE=\"hidden\" VALUE=\"{$_GET['file']}\" NAME=\"file\">
						<INPUT TYPE=\"hidden\" VALUE=\"{$_GET['format']}\" NAME=\"format\">
						Limit to <SELECT NAME=\"channel\" OnChange=\"this.form.submit();\">
						<OPTION VALUE=\"*\"";
						echo ($_GET['channel']=='*')?" SELECTED":"";
						echo '>Any</OPTION>',"\n";

						echo '<OPTION VALUE="'.$Bot->getNick().'"';
						echo ($_GET['channel']==$Bot->getNick())?" SELECTED":"";
						echo '>'.$Bot->getNick().'</OPTION>',"\n";

						echo '<OPTION VALUE="output"';
						echo ($_GET['channel']=='output')?" SELECTED":"";
						echo '>Output</OPTION>',"\n";

						$Chans=Channel::getChannels();
						foreach ($Chans as $Chan){
							echo "<OPTION VALUE=\"{$Chan}\"";
							echo ($_GET['channel']==$Chan)?" SELECTED":"";
							echo ">{$Chan}</OPTION>\n";
						}
						echo "</SELECT>";
						echo "&nbsp; <INPUT TYPE=\"image\" SRC=\"images/limit.jpg\" ALT=\"limit\" BORDER=\"0\" ALIGN=\"top\">";
						echo "\n</FORM>\n</P>";
					}
					echo "<DIV CLASS=\"LogData\">\n";

			$con=file($_GET['file']);
			//$con=array_reverse($con);
			$lkey=0;
			foreach ($con as $key=>$chat){
				if ($_GET['format']=='raw'){
					echo htmlentities(trim($chat)), "<BR>\n";
				}
				else if ($_GET['channel']=='output'){
					if ($chat{0} != ':' && ($chat{0}.$chat{2}.$chat{3}) != 'PNG'){
						while ($key > 0 && $con[$key]{0} != ':'){
							$key--;
						}
						if ($key > 0 && $key != $lkey){
							echo convertCodes($con[$key]);
							echo "<BR>\n";
							$lkey=$key;
						}
						echo convertCodes($chat);
						echo "<BR>\n";
					}
					else if (($chat{0}.$chat{2}.$chat{3}) == 'PNG'){
						echo $chat;
						echo "<BR>\n";
					}
				}
				else {
					$pattern=getBreakPattern($chat);
					if ($pattern != null){
						$Info=makeDataArray($pattern);

						$B='';
						$SB='';
						if (strtolower($Info['NICK'])==strtolower($Admin->getNick())){
							$B='<B>';
							$SB='</B>';
						}

						if (strlen($Info['MSG']) > 100 && strpos($Info['MSG'], ' ') == false){
							$Info['MSG']=substr($Info['MSG'], 0, 100)."\n".substr($Info['MSG'], 100);
						}
						if ($Info['BREAK_TYPE']=='CTCPMSG'){
							if ($Info['DEST'] == $_GET['channel'] || $_GET['channel']=='*'){
								$End=strpos($Info['MSG'], ' ');
								$Cmd=trim(substr($Info['MSG'], 1, $End?$End:strlen($Info['MSG'])));
								$Msg=($End==strlen($Info['MSG']))?'':substr($Info['MSG'], $End+1);
								if ($Cmd=='ACTION'){
									echo "*** {$Info['NICK']}:<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN> ";
									echo ConvertCodes($Msg), "<BR>\n";
								}
								else {
									echo "[{$Info['NICK']}:<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN> ";
									echo ConvertCodes(strtoupper($Cmd)), "] ", ConvertCodes($Msg), "<BR>\n";
								}
							}
						}
						else if ($Info['BREAK_TYPE']=='NORMALMSG'){
							if ((strtoupper($Info['DEST']) == strtoupper($_GET['channel'])) || 
								(strtoupper($Info['DEST']) == ':'.strtoupper($_GET['channel'])) || 
                        ($_GET['channel']=='*')){

								if ($Info['TYPE']=='PRIVMSG'){
									echo "{$B}&lt;{$Info['NICK']}:<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN>&gt; ";
									echo ConvertCodes($Info['MSG']), "{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='NOTICE'){
									echo "{$B}- {$Info['NICK']}:<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN> - ";
									echo ConvertCodes($Info['MSG']), "{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='TOPIC'){
									echo "{$B}<SPAN STYLE=\"color: #a44400\">*** {$Info['NICK']} change the topic of ";
									echo "<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN>";
									echo " to \"", ConvertCodes($Info['MSG']), "\"</SPAN>{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='MODE'){
									echo "{$B}<SPAN STYLE=\"color: #0000AF\">*** {$Info['NICK']}:";
									echo "<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN>";
									echo " sets mode(s): ";
									echo ConvertCodes($Info['MSG']), "</SPAN>{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='KICK'){
									$Who=substr($Info['MSG'], 0, strpos($Info['MSG'], ':'));
									$Why=substr($Info['MSG'], strpos($Info['MSG'], ':')+1);
									echo "{$B}<SPAN STYLE=\"color: #AF0000\">*** {$Who} has been kicked from ";
									echo "<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN>";
									echo " by {$Info['NICK']} ({$Why})</SPAN>{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='QUIT'){
									$Why=$Info['DEST'].' '.$Info['MSG'];
									$Why=substr($Why, 1);
									echo "{$B}<SPAN STYLE=\"color: #AF0000\">*** {$Info['NICK']} has quit IRC ({$Why})</SPAN>{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='PART'){
									echo "{$B}<SPAN STYLE=\"color: #FF00FF\">*** {$Info['NICK']} has left ";
									echo "<SPAN STYLE=\"color: #004F00;\">{$Info['DEST']}</SPAN> ";
									if (!empty($Info['MSG'])){
										echo '(' . $Info['MSG'] . ')';
									}
									echo "</SPAN>{$SB}<BR>\n";
								}
								else if ($Info['TYPE']=='JOIN'){
									echo "{$B}<SPAN STYLE=\"color: #606030\">*** {$Info['NICK']} has joined ";
									echo '<SPAN STYLE="color: #004F00;">'.substr($Info['DEST'], 1).'</SPAN>';
									echo "</SPAN>{$SB}<BR>\n";
								}
							}

							if ($Info['TYPE']=='NICK'){
								$NewNick=substr($Info['DEST'], 1);
								echo "{$B}<SPAN STYLE=\"color: #0000A0\">*** {$Info['NICK']} is now known as {$NewNick}";
								echo "</SPAN>{$SB}<BR>\n";
							}

						}
					}
				}
			}
			echo "\n</DIV><A NAME=\"bottom\"></A>\n<P><A HREF=\"#top\">Go to top</A></P>\n";
		}
		break;
	}
	case 'run':{
		echo '<P>Enter the command that you want to send to the IRC server below.';
		echo 'This command will be run just as if you had done <B>/msg '.$Bot->getNick().' &lt;command&gt; &lt;params&gt;</B> on IRC';
		echo ' You will have to check the latest log file for the output of the command.  That information is not avaiable here ';
		echo 'simple because it can take upto two minutes to run your command if there isn\'t much IRC activity.</P>';
		if ($_POST['cmd']){
			$String=':'.$Admin->getNick().'!'.$Admin->getProperty('Ident').'@';
			$String.=$Admin->getProperty('Hostmask').' PRIVMSG '.$Bot->getNick().' :';
			$String.=$_POST['cmd'];
			if (db_query("INSERT INTO offline_cmds(RawLine, Timestamp) VALUES ('{$String}',UNIX_TIMESTAMP())")){
				echo '<P>Your command has been sent.  It can take anywhere from a few seconds to a few minutes to run.  ';
				echo 'Just <A HREF="admin.php?action=review">keep an eye</A> on the latest log file.';
			}
		}
		echo '<P>&nbsp;</P>';
		echo '<FORM ACTION="admin.php?action=run" METHOD="Post">';
		echo '/msg '.$Bot->getNick().' <INPUT TYPE="text" VALUE="" NAME="cmd"><BR>';
		echo '<INPUT TYPE="submit" VALUE="Send"></FORM>';
		break;
	}
	case 'modules':{
		$Mods=array(); //To check the install process to limit to only modules that are NOT installed.
		echo "<CENTER><H1>Installed modules</H1></CENTER>\n";
		$res=db_query("SELECT ModDir, ModName, ModID FROM modules");
		if (!$res || db_num_rows($res)==0){
			echo "<P>There are currently no installed moduels. If you would like to install one, please upload it's <B>\n";
			echo "install.sql</B> file. If you have no modules, feel free to ";
			echo "visit our site and see if there are any that interest you.</P>";
		}
		else {
			echo "<CENTER><TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\">\n<TR>\n\t";
			echo "<TH>Module</TH>\n\t";
			echo "<TH>Directory</TH>\n\t";
			echo "<TH>Options?</TH>\n\n";
			echo "</TR>\n";
			while ($row=db_get_row($res)){
				echo "<TR>\n\t<TD>{$row->ModName}</TD>\n\t<TD>mods/{$row->ModDir}</TD>\n\t";
				echo "<TD><A HREF=\"admin.php?action=modules_delete&module_name=".urlencode($row->ModName)."\">Remove</A> - ";
				echo "<A HREF=\"admin.php?action=modules_install&module_name=".urlencode($row->ModName)."\">Update</A></TD>";
				echo "\n</TR>\n";
			}
			echo "</TABLE></CENTER>";
		}
	}
	case 'modules_install':{
		if (!isset($_FILES['installsql']) || strtolower($_FILES['installsql']['name']) != 'install.sql'){
			if (!isset($_GET['module_name'])){
				echo '<BR><CENTER><H1>Install a module</H1></CENTER><HR>';
				echo '<P>To install a module, click the <B>Browse</B> button and go to the directory you downloaded and ';
				echo 'unzipped the module to.  Find the install.sql file (type \'*.sql\' in the file box to see only sql ';
				echo 'files) and open it then click the <B>Install Now!</B> button.  Depending on the size of the module ';
				echo 'you have, it may take some time to install.</P>';
			}
			else {
				echo "<BR><CENTER><H1>Update {$_GET['module_name']}</H1></CENTER><HR>";
				echo '<P>To update the '.$_GET['module_name'].' module just copy any new command files that may have come ';
				echo 'with the new version where they should be (which may be done for you when you unzip it) and then ';
				echo 're-upload and install the install.sql file.  This should setup the database for any changes that may ';
				echo 'have been made.  You should make sure that you read the README or INSTALL files if there are any because ';
				echo 'they may have special instructions for updateing the module.</P>';
			}
			echo '<FORM NAME="module" ACTION="admin.php?action=modules_install" METHOD="post" ENCTYPE="multipart/form-data">';
			echo '<INPUT TYPE="file" NAME="installsql">';
			echo '<BR><INPUT TYPE="submit" VALUE="Install Now!"></FORM>';
			break;
		}
		else {
			$file=file($_FILES['installsql']['tmp_name']);
			$Query="";
			$Errors=array();
			$ModName='';
			foreach ($file as $linenum=>$line){
				$line=trim($line);
				if (!empty($line)){
					if ($line{0}.$line{1}=='#-'){
						$ModName=substr($line, 2);
					}
					else {
						$Query.=$line;
						if ($line{strlen($line)-1} == ';'){
							if (!db_query($Query)){
								$Errors[]=$linenum.chr(1).db_sql_error();
							}
							$Query='';
						}
					}
				}
			}
			
			header_html('Installing module -=- '.$ModName);
			if (count($Errors) > 0){
				echo "<P>Well, I tried but there were some errors while installing this module.  You may need to contact the ";
				echo "author of the module and let him or her know about these errors.  It would probably help if you ";
				echo "included a copy of this page so they could see for them selves.</P>";
				foreach ($Errors as $Num=>$error){
					echo '<P>Error number ', $Num+1, ':<BR>';
					echo 'Line: ', substr($error, 0, strpos($error, chr(1))), '; <B>',substr($error, strpos($error, chr(1)+1));
					echo '</P>',"\n";
				}
			}
			else {
				echo "<P>Success.  The <B>{$ModName}</B> module has been installed.  Now, this may not be the last of the ";
				echo 'install. Check the readme file that came with the module because you may have to move some files into ';
				echo 'specific folders before the module will actually work.  The only thing that this install does is prepares ';
				echo 'your database for the module.</P>';
			}
		}
		break;
	}
	case 'modules_delete':{
		if (isset($_GET['module_name'])){
			$res=db_query("DELETE FROM modules WHERE ModName='{$_GET['module_name']}'");
			if ($res && db_affected_rows()!=0){
				echo "<P>Success.  The <B>{$_GET['module_name']}</B> module has been removed.  The module is no longer ";
				echo "active in the bot, but it's files still exists.  If you want to remove those too, you will need to ";
				echo "do so yourself.</P>";
			}
			else if ($res){
				$res=db_query("SELECT COUNT(*) as c FROM modules");
				if (!$res || ($row=db_get_row($res) && $row->c != 0)){
					echo "<P>Sorry but the module {$_GET['module_name']} couldn't be deleted.  There must have been a ";
					echo "database error or something.  Please try and remove it from the database manually using the ";
					echo "following query:<BR>DELETE FROM modules WHERE ModName='{$_GET['module_name']}';</P>";
				}
				else {
					echo "<P>Success.  The <B>{$_GET['module_name']}</B> module has been removed.  The module is no longer ";
					echo "active in the bot, but it's files still exists.  If you want to remove those too, you will need to ";
					echo "do so yourself.</P>";
				}
			}
			else {
					echo "<P>Sorry but the module {$_GET['module_name']} couldn't be deleted.  There must have been a ";
					echo "database error or something.  Please try and remove it from the database manually using the ";
					echo "following query:<BR>DELETE FROM modules WHERE ModName='{$_GET['module_name']}';</P>";
			}
		}
		echo "<P>Select from the list below which module you would like to remove.  Please remember that ";
		echo "removing a module here will only deactivate it.  The files for the module will still remain on your ";
		echo "computer so you may re-install it if you wish.</P>";

		$Mods=array(); //To check the install process to limit to only modules that are NOT installed.
		echo "<CENTER><H1>Installed modules</H1></CENTER>\n";
		$res=db_query("SELECT ModDir, ModName, ModID FROM modules");
		if (!$res || db_num_rows($res)==0){
			echo "<P>There are currently no installed moduels. If you would like to install one, please upload it's <B>\n";
			echo "install.sql</B> file. If you have no modules, feel free to ";
			echo "visit our site and see if there are any that interest you.</P>";
		}
		else {
			echo "<CENTER><TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\">\n<TR>\n\t";
			echo "<TH>Module</TH>\n\t";
			echo "<TH>Directory</TH>\n\t";
			echo "<TH>Options?</TH>\n\n";
			echo "</TR>\n";
			while ($row=db_get_row($res)){
				echo "<TR>\n\t<TD>{$row->ModName}</TD>\n\t<TD>mods/{$row->ModDir}</TD>\n\t";
				echo "<TD><A HREF=\"admin.php?action=modules_delete&module_name=".urlencode($row->ModName)."\">Remove</A> - ";
				echo "</TD>";
				echo "\n</TR>\n";
			}
			echo "</TABLE></CENTER>";
		}
		break;
	}
	default:{
		echo "<P>Help, I'm lost!  I dunno what you want me to do here.  The action you told me is something that I cannot 
			find so I cannot do anything but sit and cry because I can't help.  Please go to the main page and make sure 
			that the URL is still valid if you came from a bookmark or posted URL.  If you came from a URL on this site, 
			please tell my master that I am broken and need a fix up.  Thank you much.</P>";
	}
}

footer();
?>
