<?php

include("./common.php");

if (!isset($_GET['user']) || !User::Exists(stripslashes($_GET['user']))){
	if (isset($_GET['user'])){
		header_html("No such nick");
		echo '<P>The nick you have selected does not appear to be one that I have seen before.  Please select and new nick';
		echo 'from the list or if you know the name of the person, enter their nick into the text box below and hit ';
		echo '\'Get nick info\'</P>';
	}
	else {
		header_html("Select a user");
		echo '<P>Please select a nick to information about from the list below, or if you know the name, enter it into the ';
		echo 'text box below and hit \'Get nick info\'</P>';
	}
	echo "\n\n";
	echo '<FORM ACTION="users.php" METHOD="get">',"\n";
	echo '<INPUT TYPE="text" VALUE="" NAME="user">',"\n";
	echo '<INPUT TYPE="submit" VALUE="Get nick info">',"\n";
	echo '</FORM>';
	echo "\n\n";
	echo '<HR>',"\n\n";

	$starts= array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
						'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
						']', '[', '{', '}', '|', '_', '`', '^', '\\', '*');
	$WHERE="";
	if (isset($_GET['letter']) && $_GET['letter'] != '*'){
		if ($_GET['letter']=='_'){
			$_GET['letter']='\_';
		}
		$WHERE="WHERE Nick LIKE '{$_GET['letter']}%'";
	}
	else if ((isset($_GET['letter']) && !in_array($_GET['letter'],$starts)) || !isset($_GET['letter'])){
		$WHERE="WHERE Nick LIKE 'A%'";
	}

	echo '<CENTER>';
	foreach ($starts as $letter){
		echo '<A HREF="users.php?letter='.urlencode($letter).'" STYLE="font-size:13pt;">'.$letter.'</A> &nbsp;',"\n";
	}
	echo '</CENTER><HR>';

	$res=db_query("SELECT Nick FROM users {$WHERE} ORDER BY Nick");
	if (!$res){
		echo "Database error";
	}
	else {
		echo '<CENTER><TABLE BORDER="0" CELLPADDING="3" CELLSPACING="1" WIDTH="80%">',"\n";
		echo '<TR><TH COLSPAN="4">Total Users in group: '.db_num_rows($res).'</TH></TR>',"\n";	
		$count=1;
		while ($row=db_get_row($res)){
			if ($count==1){
				echo '<TR>';
			}
			echo "\n\t",'<TD><A HREF="users.php?user='.urlencode($row->Nick).'" CLASS="Nick">'.$row->Nick.'</A></TD>';
			if ($count==4){
				echo "\n</TR>\n";
				$count=1;
			}
			else {
				$count++;
			}
		}
		while ($count != 1 && $count++ < 5){
			echo "\n\t<TD>&nbsp;</TD>";
			if ($count==4){
				echo "\n</TR>\n";
			}
		}
		echo '</TABLE></CENTER>',"\n";
	}
}
else {
	$User=new User(stripslashes($_GET['user']));
	header_html("User statics for ".$User->getNick());
	echo "<H1>Stats for <B><I>".$User->getNick()."</I></B></H2>\n";
	
	$LastMsgTime=date('m/d/Y h:i.s',$User->getProperty('LAction'));
	$LActionText=stripslashes(htmlentities($User->getProperty('LActionText')));
	if (strlen($LActionText) > 85 && (strpos($LActionText, ' ') == false || count(explode(' ',$LActionText)) <= 2)){
		$LActionText=substr($LActionText, 0, 85)."\n".substr($LActionText, 85);
	}

	$ChannelList='';
	$UsersChannels=Channel::getChannels($User);
	foreach ($UsersChannels as $Chan){
		$Chan=new Channel($Chan);
		if ($Chan->isOp($User)){
			$ChannelList.='@';
		}
		else if ($Chan->isHalfOp($User)){
			$ChannelList.='%';
		}
		else if ($Chan->isVoice($User)){
			$ChannelList.='+';
		}
		
		$ChannelList.=htmlentities($Chan->getName());

		$ChannelList.='<BR>';
	}
			
	echo '<TABLE BORDER="0" CELLPADDING="2" CELLSPACING="1" WIDTH="75%">', "\n";
	echo '<TR><TH ALIGN="right">Nick:</TH><TD>&nbsp;'.$User->getNick().' (ID: '.$User->getID().')</TD></TR>',"\n";
	echo '<TR><TH ALIGN="right">Ident:</TH><TD>&nbsp;'.$User->getProperty('Ident').'</TD></TR>',"\n";
	echo '<TR><TH ALIGN="right">Host:</TH><TD>&nbsp;'.$User->getProperty('Hostmask').'</TD></TR>',"\n";
	echo '<TR><TH ALIGN="right">Last&nbsp;Message&nbsp;Time:</TH><TD>&nbsp;'.$LastMsgTime.'</TD></TR>',"\n";
	echo '<TR><TH ALIGN="right">Last Message:</TH><TD>&nbsp;'.$LActionText.'</TD></TR>',"\n";
	echo '<TR><TH ALIGN="right" VALIGN="top">Channels:</TH><TD>'.$ChannelList.'&nbsp;</TD></TR>',"\n";
	echo '</TABLE>';

	//********** Modules **********************//
	$__MODS_RES=db_query("SELECT ModName, ModDir FROM modules");
	if ($__MODS_RES && db_num_rows($__MODS_RES)>=1){
		echo '<CENTER><H1>Installed Modules</H1></CENTER><HR>';
		while ($row=db_get_row($__MODS_RES)){
			if (file_exists('./mods/'.$row->ModDir.'/..USER_WEB.php')){
				echo "<CENTER><H3>{$row->ModName}</H3></CENTER>\n";
				include('./mods/'.$row->ModDir.'/..USER_WEB.php');
			}
		}
	}
}

footer();
?>
